--LOAD
myWorld:addClass("ObjectA")
myWorld:addClass("ObjectB")
myWorld:addClass("Player", {"ObjectB"})
--hero start position
for k, object in pairs(map.objects) do
    if object.name == "Player" then
        player = object
        break
    end
end
--pot starting position
for k, object in pairs(map.objects) do
    if object.name == "Pot" then
        pot = object
        break
    end
end
--box starting position
for k, object in pairs(map.objects) do
    if object.name == "Box" then
        box = object
        break
    end
end
--chair starting setPosition
for k, object in pairs(map.objects) do
    if object.name == "Chair" then
        chair = object
        break
    end
end
--custom layers
layer = map:addCustomLayer("Sprites",3)
--create player object
layer.player = {}
  layer.player.ox = player.width/2
  layer.player.oy = player.height/1.5
  layer.player.collider =  myWorld:addCircle(
  player.x + layer.player.ox,
  player.y + player.height/2,
  player.width/3
  )
  layer.player.vx = 0
  layer.player.vy = 0
  layer.player.direction = "south"
  layer.player.state = "standing"
  layer.player.speed = 16*4
  layer.player.collider:setFixedRotation(true)
  layer.player.collider:setClass("Player") --player object ignores static objects

--create pot object
layer.pot = {}
  layer.pot.ox = pot.width/2
  layer.pot.oy = pot.height/2
  layer.pot.collider =  myWorld:addCircle(
  pot.x + layer.pot.ox,
  pot.y - layer.pot.oy,
  pot.width/3
  )
  layer.pot.collider:setFixedRotation(true)
  layer.pot.collider:setFriction(0.2)
  layer.pot.collider:setDensity(2)
  layer.pot.collider:resetMassData()
  layer.pot.collider:setClass("ObjectA") --normal dynamic object

  --create box object
  layer.box = {}
    layer.box.ox = box.width/2
    layer.box.oy = box.height/2
    layer.box.collider =  myWorld:addRectangle(
    box.x + layer.box.ox,
    box.y - layer.box.oy,
    box.width,
    box.height
    )
    layer.box.collider:setFixedRotation(true)
    layer.box.collider:setFriction(0.4)
    layer.box.collider:setDensity(4)
    layer.box.collider:resetMassData()
    layer.box.collider:setClass("ObjectA") --normal dynamic objcets

    --create chair object
  layer.chair = {}
    layer.chair.ox = chair.width/2
    layer.chair.oy = chair.height/2
    layer.chair.collider =  myWorld:addRectangle(
    chair.x + layer.chair.ox,
    chair.y - layer.chair.oy,
    chair.width/2,
    chair.height/2
    )
    layer.chair.collider:setType("static")
    layer.chair.collider:setClass("ObjectB") --static but still an objcet

--UPDATE
layer.update = function(self, dt)
      --movement
  if love.keyboard.isDown("w","up") then
      self.player.vy = -1
      self.player.direction = "north"
  elseif love.keyboard.isDown("s","down") then
      self.player.vy = 1
      self.player.direction = "south"
  else
      self.player.vy = 0
  end
  if love.keyboard.isDown("a","left") then
      self.player.vx = -1
      self.player.direction = "west"
  elseif love.keyboard.isDown("d","right") then
      self.player.vx = 1
      self.player.direction = "east"
  else
      self.player.vx = 0
  end

  --control player state
  self.player.collider:setPostsolve(function(s1,s2)
      if s2:getClass() == "ObjectA" then
          self.player.state = "pushing"
      end
  end)
  if self.player.vx == 0 and self.player.vy == 0 then
    self.player.state = "standing"
  else
    self.player.state = "walking"
  end
  --update player velocity
  self.player.collider:setLinearVelocity(
  self.player.vx * self.player.speed,
  self.player.vy * self.player.speed
  )
  --math.floor fixes the shaking camera and locks onto integer values only
  cam:setPosition(
  math.floor(self.player.collider:getX()),
  math.floor(self.player.collider:getY())
  )
end


--DRAW
layer.draw = function(self)
local pose = sprites.stand_cycle --default pose when nothing has been pressed
--player shadow
love.graphics.setColor(0,0,0,0.5)
love.graphics.ellipse(
"fill",
math.floor(self.player.collider:getX()),
math.floor(self.player.collider:getY()) + 5,
6,
3
)
love.graphics.setColor(1,1,1,1)
--draw ordinary objects behind the player
love.graphics.draw(
sprites.pot,self.pot.collider:getX(),self.pot.collider:getY(),
0,1,1,self.pot.ox,self.pot.oy
)
self.pot.collider:setLinearVelocity(0, 0) --stop pot if nothing moves it
love.graphics.draw(
sprites.box,self.box.collider:getX(),self.box.collider:getY(),
0,1,1,self.box.ox,self.box.oy
)
self.box.collider:setLinearVelocity(0, 0) --stop box if nothing moves it
love.graphics.draw(
sprites.chair,self.chair.collider:getX(),self.chair.collider:getY(),
0,1,1,self.chair.ox,self.chair.oy
)
--draw the player over everything else
  if self.player.state == "pushing" then
    pose = sprites.player_pushing
  elseif self.player.state == "walking" then
    pose = sprites.player_walking
  elseif self.player.state == "standing" then
    pose = sprites.player_standing
  end
  --direction is handled here (1 = south, 2 = west, 3 = east, 4 = north)
  if self.player.direction == "south" then
    hero[1]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
    0,1,1,self.player.ox,self.player.oy)
  end
  if self.player.direction == "west" then
    hero[2]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
    0,1,1,self.player.ox,self.player.oy)
  end
  if self.player.direction == "east" then
    hero[3]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
    0,1,1,self.player.ox,self.player.oy)
  end
  if self.player.direction == "north" then
    hero[4]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
    0,1,1,self.player.ox,self.player.oy)
  end
end
--remove unneeded object layers
map:removeLayer("POS")
